c
      subroutine element(x,y,x1,y1,x2,y2,dxx,sig,idble,F1,F2,F3,
     +                   fxx,fyy,fzz)
c
      implicit real*8(a-h,o-z)
c
      common/plate/rlam1,rlam2,rmu1,rmu2,rho,rc,rd,alph,pi
c
c       create the force vector for this element
c
c       input:
c
c       x, y    - computation point      (km)
c       x1,y1   - start position         (km)
c       x2,y2   - end position           (km)
c       dxx     - grid spacing           (km)
c       sig     - source width in pixels (try 1)
c       idble   - (0-single couple, 1-double couple)
c       F1      - strike-slip
c       F2      - dip-slip
c       F3      - opening mode
c
c       output:
c
c       fxx     - x-component of force couple
c       fyy     - y-component of force couple
c       fzz     - z-component of force couple
c
c  set the x and y taper lengths
c
      sigy=sig
      print*,F1,'old'
c  sigx  should be = 2 or perhaps 4
c
      sigx=2.0
c
c  compute the length and orientation of the fault
c
      Dx=(x2-x1) 
      Dy=(y2-y1) 
      L=sqrt(Dx*Dx+Dy*Dy) 
      theta=atan2(Dy,Dx) 
      st=sin(theta) 
      ct=cos(theta) 

c
c  rotate the vector into the model space
c
      x0=x-x1 
      y0=y-y1 
      xp=x0*ct+y0*st 
      yp=-x0*st+y0*ct 
 
c  compute the h and dh/dx functions
c
      h=exp(-0.5*((yp/sigy)**2))/(sqrt(2*pi)*sigy)/(dxx*dxx) 
      dh=-yp*exp(-0.5*((yp/sigy)**2))/(sqrt(2*pi)*sigy**3)/(dxx*dxx) 
c
c   compute the g and dgdx functions
c
      if(xp .gt. -sigx .and. xp .lt. sigx) then
         g=0.5*(1-cos(pi*(xp+sigx)/(2*sigx))) 
         dg=pi*sin(pi*(xp+sigx)/(2*sigx))/(4*sigx)
      else if(xp .ge. sigx .and. xp .le. L-sigx) then
         g=1. 
         dg=0.
      else if(xp .gt. L-sigx .and. xp .lt. L+sigx) then
         g=0.5*(1-cos(pi*(L+sigx-xp)/(2*sigx))) 
         dg=-pi*sin(pi*(L+sigx-xp)/(2*sigx))/(4*sigx)
      else
         g=0. 
         dg=0.
      endif
c
c extract components
c
c some thoughts:
c if F1 only (F2 and F3 =0) this program works fine

c if we don't want to include secondary couples for opening/closing mode,
c  (to match Okada), this program also works fine but must make 
c  sfxx, sfyy, sfzz = 0.


c  primary couple
c
      pfxx=g*dh*(-F1*ct+F3*st)
      pfyy=g*dh*(F1*st+F3*ct)
      pfzz=g*dh*F2 
      
      sfxx=0.
      sfyy=0.
      sfzz=0.
           
c  secondary couple(s)
c
      if(idble.eq.1) then
      
        pfxx=0.
	pfyy=0.
	pfzz=0.
	
c        sfxx=dg*h*(F1*st + F3*ct) + g*h*(F2*st)
c        sfyy=dg*h*(F1*ct + F3*st) + g*h*(F2*ct)    
	sfzz=g*h*F3  

c note:  fzz needs to be made 0 for secondary couple in y-direction
c	 for opening/closing faults
c	 still need to fix this!!!!

c note:  also need to scale F3 back to shear mod. for secondary couples
c	 still need to fix this!!!


      endif

c sum the primary and secondary couples (double couple)

	fxx=pfxx+sfxx
	fyy=pfyy+sfyy
	fzz=pfzz+sfzz
      
      
      return
      end
        
	
	
	
c ***************  JUNK	****************
c
c	fxx=fxx+dg*h*F1*st
c        fyy=fyy+dg*h*F1*ct        
c
c testing upper and lower individual double couple components
c temporarily making fz 0 
c
c	fxx=fxx + dg*h*F1*st + fxx2 
c        fyy=fyy + dg*h*F1*ct + fyy2
c	fzz=0
c
c	fxx=g*dh*(F3*st) 	
c
c	fxx=0				
c	fyy=0			
c	fzz=g*h*F3		
c
c	fyy=dg*h*(F3*st)
c	fxx=0
c	fzz=0
